Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000784Core InformActionspublic2011-10-30 20:522014-05-07 07:33
Assigned Tograham 
PlatformOSOS Version
Product Version6G60 
Target VersionFixed in Version6L02 
Summary0000784: "doing something other than Xing the Y" is handled wrong
DescriptionIn the sample code, nearly every action should be ruled out. At least, that would be the natural reading.

Instead, rule 1 is compiled as "instead of doing anything-other-than-touching to the pear". So the pear cannot be dropped, but the apple and banana can both be dropped.

Similarly, rule 2 blocks doing anything-other-than-putting-it-on to (apple, pillar). So it successfully blocks "put apple in pillar", but nothing involving the banana or any other object in the room.
Minimal Source Text To Reproduce
The Kitchen is a room.

The player carries the apple.
The player carries the pear.
The player carries the banana.

The small pillar is a fixed in place supporter in the Kitchen.

Instead of doing something other than touching the pear:
	say "Rule 1 fires."

Instead of doing something other than putting the apple on the pillar:
	say "Rule 2 fires."
Additional InformationKitchen
You can see a small pillar here.

>drop banana

>get banana

>drop apple

>get apple

>put banana on pillar
You put the banana on the small pillar.
TagsNo tags attached.
Effect(serious/mild) Game compiles but misbehaves
Attached Files

- Relationships
related to 0001159closedgraham The syntax for writing rules with excepted actions is prone to misinterpretation by ni 

-  Notes
graham (administrator)
2014-03-11 15:48

I tend to agree with this, and I've changed the behaviour of "doing something other than". In particular, Inform now distinguishes between

doing something other than touching the pear


doing something other than touching to the pear

and this makes for a much more natural reading of the text.

- Issue History
Date Modified Username Field Change
2011-10-30 20:52 zarf New Issue
2011-10-30 21:00 EmacsUser Status new => confirmed
2013-12-25 15:52 EmacsUser Relationship added related to 0001159
2014-03-11 15:48 graham Note Added: 0002550
2014-03-11 15:48 graham Status confirmed => resolved
2014-03-11 15:48 graham Resolution open => fixed
2014-03-11 15:48 graham Assigned To => graham
2014-05-07 07:32 jmcgrew Fixed in Version => 6L02
2014-05-07 07:33 jmcgrew Status resolved => closed

Copyright © 2000 - 2010 MantisBT Group
Powered by Mantis Bugtracker